%define target		avr
%define Werror_cflags	-Wformat
%define rel		1
%define subrel		1

Name:           cross-%{target}-gcc
Version:        4.6.1
Release:        %mkrel %rel
Summary:        Cross Compiling GNU GCC targeted at %{target}
Group:          Development/C
License:        GPLv2+
URL:            http://gcc.gnu.org/
Source0:        ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-core-%{version}.tar.bz2
Source1:        ftp://ftp.gnu.org/gnu/gcc/gcc-%{version}/gcc-g++-%{version}.tar.bz2
Patch0:		cross-avr-gcc-4.6.1-mint8.patch
Patch1:		cross-avr-gcc-4.6.1-progmem.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-%(%{__id_u} -n)
BuildRequires:  cross-%{target}-binutils >= 2.21.1, zlib-devel gawk gmp-devel mpfr-devel libmpc-devel
Requires:       cross-%{target}-binutils >= 2.21.1

%description
This is a Cross Compiling version of GNU GCC, which can be used to
compile for the %{target} platform, instead of for the
native %{_arch} platform.


%package c++
Summary:        Cross Compiling GNU GCC targeted at %{target}
Group:          Development/C++
Requires:       %{name} = %{version}-%{release}

%description c++
This package contains the Cross Compiling version of g++, which can be used to
compile c++ code for the %{target} platform, instead of for the native %{_arch}
platform.


%prep
%setup -q -c
%setup -q -c -a 1
pushd gcc-%{?snapshot}%{!?snapshot:%version}

%patch0
%patch1

contrib/gcc_update --touch
popd

# Extract %%__os_install_post into os_install_post~
cat << \EOF > os_install_post~
%__os_install_post
EOF

# Generate customized brp-*scripts
cat os_install_post~ | while read a x y; do
case $a in
# Prevent brp-strip* from trying to handle foreign binaries
*/brp-strip*)
  b=$(basename $a)
  sed -e 's,find %{buildroot},find %{buildroot}%_bindir %{buildroot}%_libexecdir,' $a > $b
  chmod a+x $b
  ;;
esac
done

sed -e 's,^[ ]*/usr/lib/rpm.*/brp-strip,./brp-strip,' \
< os_install_post~ > os_install_post 


%build
mkdir -p gcc-%{target}
pushd gcc-%{target}
CC="%{__cc} %optflags" \
../gcc-%{version}/configure --prefix=%{_prefix} --mandir=%{_mandir} \
  --infodir=%{_infodir} --target=%{target} --enable-languages=c,c++ \
  --disable-nls --disable-libssp --with-system-zlib \
  --enable-version-specific-runtime-libs \
  --with-pkgversion="Mandriva %{version}-%{release}" \
  --with-bugurl="https://qa.mandriva.com/" \
  --libexecdir=%{_libexecdir}
# In general, building GCC is not smp-safe
make
popd


%install
rm -rf %{buildroot}
pushd gcc-%{target}
make install DESTDIR=%{buildroot}
popd
# we don't want these as we are a cross version
rm -rf %{buildroot}%{_infodir}
rm -rf %{buildroot}%{_mandir}/man7
rm    %{buildroot}%{_libdir}/libiberty.a
# and these aren't usefull for embedded targets
rm -rf %{buildroot}/usr/lib/gcc/%{target}/%{version}/install-tools
rm -rf %{buildroot}%{_libexecdir}/gcc/%{target}/%{version}/install-tools

%define __os_install_post . ./os_install_post


%clean
rm -rf %{buildroot}


%files
%defattr(-,root,root,-)
%doc gcc-%{version}/COPYING gcc-%{version}/COPYING.LIB
%{_bindir}/%{target}-*
%dir /usr/lib/gcc
%dir /usr/lib/gcc/%{target}
/usr/lib/gcc/%{target}/%{version}
%dir %{_libexecdir}/gcc
%dir %{_libexecdir}/gcc/%{target}
%{_libexecdir}/gcc/%{target}/%{version}
%{_mandir}/man1/%{target}-*.1.xz
%exclude %{_bindir}/%{target}-?++
%exclude %{_libexecdir}/gcc/%{target}/%{version}/cc1plus
%exclude %{_mandir}/man1/%{target}-g++.1.xz

%files c++
%defattr(-,root,root,-)
%{_bindir}/%{target}-?++
%{_libexecdir}/gcc/%{target}/%{version}/cc1plus
%{_mandir}/man1/%{target}-g++.1.xz


%changelog
* Wed Oct 26 2011 Andrey Smirnov <asmirnov@mandriva.org> 4.6.1-1.1mdv2011.0
+ Revision: 707246
- Package backported from Cooker to fix broken dependencies (see bug #64347)

* Fri Jun 04 2010 Yvan T. <yvanttt@mandriva.org> 4.4.3-7mnb2
+ Revision: 547124
- Updated dependencies to include avr-libc
- updated dependencies.
  was missing required avr-libc package

* Thu May 20 2010 Stéphane Téletchéa <steletch@mandriva.org> 4.4.3-6mnb2
+ Revision: 545465
- Revert to revision r530597 as recommended by Herton K.
- Bump release to remove old broken packages

* Tue May 18 2010 Stéphane Téletchéa <steletch@mandriva.org> 4.4.3-5mnb2
+ Revision: 545084
- Bump release for submission

  + Yvan T. <yvanttt@mandriva.org>
    - corrected intermitent null pointer warnigs while using arduino IDE
    - Updated package.
      moved static headers and libraries to a new package lib-avr
      SVN: Line begining by SVN are ignored

* Thu Apr 01 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 4.4.3-4mnb2
+ Revision: 530597
- Temporary avoid clash with system gcc with lesser release.

* Thu Apr 01 2010 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 4.4.3-3mnb2
+ Revision: 530553
- Revert broken and uneeded changes from previous commit (cosmetic
  changes can be done on main gcc package instead of here).

  + Yvan T. <yvanttt@mandriva.org>
    - rebuild package to bring it to current level
      added dependencies avr-libc.
      corrected missing file attributes that would prevented access to some librairies

* Tue Feb 09 2010 Funda Wang <fwang@mandriva.org> 4.4.3-2mnb2
+ Revision: 502804
- rebuild for new gmp

* Fri Jan 29 2010 Funda Wang <fwang@mandriva.org> 4.4.3-1mnb2
+ Revision: 497891
- New version 4.4.3
- CVE 2009-3736 patch merged

* Mon Dec 28 2009 Herton Ronaldo Krzesinski <herton@mandriva.com.br> 4.4.2-1mnb2
+ Revision: 483196
- Updated and sync with latest gcc package in svn (r476411).
- Bump build/requires for latest cross-avr-binutils.
- Build for avr target (used by avr-libc, arduino ide...).
- Reset release.
- Enable also c++, probably not working right now, hacked spec to allow
  its build.
- Build fixes.
- Don't disable multilib, required by avr target.
- gcc.spec: rename to cross-avr-gcc.spec
- Branch cross-avr-gcc from gcc package.

  + Thierry Vignaud <tv@mandriva.org>
    - split checks in %%check
    - more more doc from libstdc++-devel and gcc-c++ into gcc-doc
    - use ln instead of cp (less disk usage, faster)

* Tue Sep 29 2009 Christophe Fergeau <cfergeau@mandriva.com> 4.4.1-3mnb2
+ Revision: 450840
- another attempt at fixing the libgcj_bc stuff.
  The previous change wasn't a good idea because non-system compilers' libgcj_bc
  would obsolete the system libgcj_bc which is a bad idea :)

* Mon Sep 28 2009 Christophe Fergeau <cfergeau@mandriva.com> 4.4.1-2mnb2
+ Revision: 450607
- One more attempt at fixing libgcj_bc packaging
- don't ship libgcj_bc shared libs both in libgcj10 and libgcj_bc1
  should fix bug #54121

* Thu Jul 23 2009 Christophe Fergeau <cfergeau@mandriva.com> 4.4.1-1mnb2
+ Revision: 398776
- upload gcc 4.4.1 tarball
- preparation for gcc 4.4.1 (couldn't find it on the mirrors yet)

* Mon Jul 20 2009 Anssi Hannula <anssi@mandriva.org> 4.4.0-5mnb2
+ Revision: 398069
- remove python files from gcj-tools that conflicted with
  java-1.5.0-gcj-devel

* Sat Jul 18 2009 Anssi Hannula <anssi@mandriva.org> 4.4.0-4mnb2
+ Revision: 396976
- enable libobjc_gc (Mika Laitio)

* Wed Jun 03 2009 Christophe Fergeau <cfergeau@mandriva.com> 4.4.0-3mnb2
+ Revision: 382395
- enable cloog/ppl in the build
- Don't install aot-compile and rebuild-gcj-db since it's part of java-1.5.0-gcj
- remove meaningless comment, disable -Wformat=error :-/
- only do try find locale files for libstdc++ if we actually build it
- check if files are present before trying to sanitize their rpath
- ada fixes
- Revert wrong hunk from wformat-fixes (see comment above it in the source)

* Tue May 19 2009 Christophe Fergeau <cfergeau@mandriva.com> 4.4.0-1mnb2
+ Revision: 377476
- Don't attempt to build ada docs when ada is disabled
- Add cloog/ppl support to build (disabled for now)
- Fix customization of gcc bug URL
- Fix spec for ada support. Don't reenable ada build for now since we don't have
  a gnat compiler available in main to bootstrap it
- enable java in build
- spec update for gcj 4.4.0
- Initial pass at a gcc 4.4 package, rediff patches and get working C and C++ compilers. java and ada and tests are disabled for now.
- Fix one more format warning
- Get rid of cputoolize
- Rediff patches against gcc 4.3.3
- Reset release counter
- Disable ada for now
- Add missing space in substitution, this bug has been here forever, dunno why it never showed up before...
- Add patch 114 to fix -Wformat=error issues
- Upload gcc 4.3.3 tarball

  + Helio Chissini de Castro <helio@mandriva.com>
    - Add another wformat fix on current patch

  + Anssi Hannula <anssi@mandriva.org>
    - split libgcj_bc to a separate package to avoid future conflicts
    - fix libgcj_bc handling of non-system-compilers (ported from gcc4.3)
    - do not require libgcj-devel in gcj-tools

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - only leave out libgcc_eh.a when building cross bootstrap (needs to be verified)
    - don't include libgomp.info when building without libgomp
    - libgmp-devel & libmpfr-devel is needed for building regardless of gfortran
    - sync some patches and configure options with gcc from gdium tree
    - fix bootstrap build of cross compiler
    - work around issue with xgcc ignoring --sysroot when cross-compiling
    - fix so that lsb-headers patches gets applied in correct location..
    - * add mips stuff to lsb-headers for cross compiling (P1000)
      * sysroot headers should go to usr/include/, not include/

  + Pixel <pixel@mandriva.com>
    - rebuild with gnat enabled

* Fri Nov 07 2008 Pixel <pixel@mandriva.com> 4.3.2-5mnb2
+ Revision: 300457
- rebuild without gnat for now (we need to rebuild libgcj first)

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild since lib{,64}gcj9 depends on libxcb-xlib.so.0 which is no more

* Fri Sep 12 2008 Pixel <pixel@mandriva.com> 4.3.2-3mnb2
+ Revision: 284163
- fix broken symlinks <platform>-gfortran and <platform>-gcj (#43341)
- when not system_compiler:
  o handle conflicts with system_compiler
  o require manbo-files-gcc%%{branch}

* Thu Sep 04 2008 Pixel <pixel@mandriva.com> 4.3.2-2mnb2
+ Revision: 280693
- rename libffi-devel back to libffi4-devel (cf #43381)

* Fri Aug 29 2008 Pixel <pixel@mandriva.com> 4.3.2-1mnb2
+ Revision: 277302
- 4.3.2
- drop db-pathtail patch (fixed upstream)
- fix build when not system_compiler
- fix build without libgomp

* Fri Jun 27 2008 Pixel <pixel@mandriva.com> 4.3.1-2mnb2
+ Revision: 229470
- snapshot 4.3-20080626 (including fix for gccbz#36533)
- do not call ldconfig in %%post/%%postun, it is now handled by filetriggers

* Mon Jun 09 2008 Pixel <pixel@mandriva.com> 4.3.1-1mnb2
+ Revision: 217093
- gcc 4.3.1
- workaround bug with redefined extern inline (mdvbz #41171, upstream #33763)
- drop alternatives for anything but c,c++,cpp
- so drop having %%version in binary names (eg: gjar instead of gjar-4.3.1),
  this implies gcj-tools conflicts with current classpath
- libgcj-devel and libgcj-static-devel must obsolete libgcj9-devel and libgcj9-static-devel

* Mon May 19 2008 Pixel <pixel@mandriva.com> 4.3.1-0.20080515mnb2
+ Revision: 208957
- snapshot 4.3-20080515
- change version in java homedir to 1.5.0
- drop logging.properties and classpath.security (bug #23693)
- load java property files from /usr/lib instead of /usr/lib64 on 64-bit
  systems (patch130, see bug #23693)
- add patch133 (db-pathtail) to fix build (??, from gcc4.3.spec)
- drop patch 104 for now, may break cross builds
  (but hopefully it can be fixed differently)
- drop old patch 117, hopefully unneeded (Ada only)
- drop now unneeded patches 118, 120, 121, 123, 125, 128
- rediff patches 202, 211
- libgcj9 conflicts with libgcj8
- gcc-java now requires eclipse-ecj
- drop require for zip from libgcj-devel, gjar is now used
- drop patch 104 for now, may break cross builds
  (but hopefully it can be fixed differently)
- be the system_compiler on mdv2009.0
- add support for building on distros where gcc4.2 is system_compiler
- libxxx-devel which have files in %%{gcc_libdir}/%%{gcc_target_platform}/%%{version} and do not require gcc must own that directory
- %%{gcc_libdir}/%%{gcc_target_platform}/%%{version}/include/bits must be owned by libstdc++-devel
  (otherwise it's not removed on upgrade to a new gcc version)
- build libffi when building java, but remove the binaries in non-system-compiler builds
- handle build_stdcxxheaders on non system_compiler (from gcc4.3.spec)
- drop support for building on mdv2007.0 and older
- drop mention of deprecated gcc-$(gcc%%{branch}-version) for non system_compiler from %%description
- use %%{buildroot} instead of $RPM_BUILD_ROOT
- handle building without libgcj_bc, and build with libgcj_bc and not system_compiler (from gcc4.3.spec)

* Mon Mar 17 2008 Pixel <pixel@mandriva.com> 4.2.3-6mnb1
+ Revision: 188307
- add requires on specific manbo-files-gcc-xxx

* Fri Mar 14 2008 Pixel <pixel@mandriva.com> 4.2.3-5mnb1
+ Revision: 187793
- increase release
- gcc can't use %%check since we need to "make check" before %%install. but still
  allow "--without check" the standard way
- %{base_release} is not needed anymore
- revert gcc-core/gcc-other split
- re-add Requires on manbo-files-gcc
  (no Requires(pre) needed since all files are not installed through the symlink)
- revert gcc-core/gcc-other split (only keeping the fixes and manbo_mkrel)
- revert gcc-core/gcc-other split
- use manbo_mkrel for gcc-core
- we must ensure manbo-files-gcc is installed prior to install of files in
  /usr/lib/gcc/*-mandriva-linux-gnu/<version>/ (otherwise manbo-files-gcc
  install will fail)

* Wed Mar 12 2008 Pixel <pixel@mandriva.com> 4.2.3-3mdv2008.1
+ Revision: 187140
- use simple "make bootstrap-lean" instead of "make profiledbootstrap"
  (it fails, it is not very useful, and jakub disabled it in fedora too)
- libjack-devel is needed to build libgjsmdssi
- java: always build with dssi-devel for libgjsmdssi

* Fri Mar 07 2008 Pixel <pixel@mandriva.com> 4.2.3-2mdv2008.1
+ Revision: 181288
- fix build on x86_64: do not create 32/libgomp.so if not build_libgomp
- add script to sync gcc-other from gcc-core
- new release: 4.2.3
- use a fixed list of include headers to keep

  + Kiichiro Naka <knaka@turbolinux.co.jp>
    - use _real_vendor not _vendor
    - gcc requires gcc-manbo-files if the vendor is "manbo"
    - fix vendor name as "manbo"
    - fix a condition macro
    - added prereq for "manbo-files-gcc"
    - remove requirement for manbo-files
    - modify misc packages require not gcc but gcc-BRANCH
    - split the SRPM to "core" and "other" for Manbo packages
    - Rename the spec file
    - Renamed from "gcc" for Manbo packages

  + Thierry Vignaud <tv@mandriva.org>
    - rebuild
    - kill re-definition of %%buildroot on Pixel's request
    - move huge (& mostly prehistoric) Changelogs in doc subpackage

  + Olivier Blin <blino@mandriva.org>
    - restore BuildRoot

* Thu Dec 06 2007 Pixel <pixel@mandriva.com> 4.2.2-2mdv2008.1
+ Revision: 115817
- new 4.2.x snapshot (includes fix for PR34130, ie -10*abs(...) => abs(10*...))

* Tue Nov 13 2007 Pixel <pixel@mandriva.com> 4.2.2-1mdv2008.1
+ Revision: 108502
- 4.2.2 final release

  + Thierry Vignaud <tv@mandriva.org>
    - s/Mandrake/Mandriva/

* Fri Sep 14 2007 Pixel <pixel@mandriva.com> 4.2.2-0.RC.1mdv2008.0
+ Revision: 85687
- 4.2.2 RC1

* Tue Aug 28 2007 Pixel <pixel@mandriva.com> 4.2.1-6mdv2008.0
+ Revision: 72838
- new svn snapshot
- get rid of one last hardlink (c++-%%{version} and g++-%%{version}) by simplifying some script
- fix build without fortran/java/c++

  + Thierry Vignaud <tv@mandriva.org>
    - kill update-alternative file require
    - kill file require on info-install

  + Christiaan Welvaart <spturtle@mandriva.org>
    - for ppc, remove ssp options from OPT_FLAGS because libgcj crashes when built with them

* Fri Aug 03 2007 Pixel <pixel@mandriva.com> 4.2.1-4mdv2008.0
+ Revision: 58669
- replace hardlinks on binaries with symlinks (#18160)
- don't mess with binaries gcc-%%{version} and %%{gcc_target_platform}-gcc (#18160)
  so that they are correctly the same file (hardlinks)
- do package binary %%{gcc_target_platform}-gcc-%%{version}
- do not package /usr/bin/gcj (as used to be in 4.1 pkg), otherwise alternatives are broken
  (nb: it breaks cooker to cooker upgrade, please fix by hand)
- new svn snapshot from 4.2 branch
- drop applied gcc-ada-gnat_ugn-info-fix.patch
- normalize %%clean (#18155)
  (maybe it was used by gb to keep test_summary.log, this is no longer needed)
- add -%%{version} suffix to gkeytool to avoid conflict with classpath

  + Anssi Hannula <anssi@mandriva.org>
    - disable libgcj_bc.so.1 provides from the libgcj-devel package, only
      libgcj8 itself should provide it

* Fri Jul 06 2007 Pixel <pixel@mandriva.com> 4.2.1-3mdv2008.0
+ Revision: 48942
- get rid of colorgcc (it will be in its own package)
- libstdc++.mo files from libstdc++ to gcc-c++ (to respect proper libification)
- don't package /usr/lib/gcj-4.2.1/*.la files
- add -%%{version} suffix to gappletviewer/gjarsigner to avoid conflict with classpath
- libstdc++-static-devel doesn't conflict with other libstdc++X-static-devel pkgs
- libgcj-devel doesn't conflict with other libgcjX-devel pkgs
- libgcj-static-devel doesn't conflict with other libgcjX-static-devel pkgs
- libstdc++-devel doesn't conflict with other libstdc++X-devel pkgs
- add obsolete/provide from libstdc++-static-devel on libstdc++6-static-devel
- fix obsolete from libffi-devel (it is now on libffi4-devel), and add provide
- add provides on obsoleted libstdc++6-devel (#31765)

* Thu Jul 05 2007 Pixel <pixel@mandriva.com> 4.2.1-2mdv2008.0
+ Revision: 48664
- 4.2.1 RC1
- use libxxx-devel instead of libxxx1-devel for libstdc++-devel, libgcj-devel,
  libffi-devel, libmudflap-devel, libssp-devel, libgomp-devel
- simplify conflicts on previous devel packages
- drop biarch_java support from .spec (it was already disabled)
- have the test_summary.log in the right place
- fix gcj_libdir (it is in lib64 on x86_64)
- use %%{gcj_libdir} macro, and drop the duplicated %%{gcj_libdir} entry
- we currently can't have a nice fixed list of *.h not to bundle, so don't die
  when removing non existing *.h
- zip is required to build libjava
- 4.2.0 svn snapshot
- drop libgcjawt renaming (still needed? maybe not since it has moved)
- package the result of tests to allow comparing when building a new gcc
- package libstdc++.mo files
- move branch to mainstream
- replacing with branch version

  + Anssi Hannula <anssi@mandriva.org>
    - remove classpath.security and logging.properties as they now reside in
      jpackage-utils (fixes bug #23693)
    - add biarch handling for libgcj-tools and libgcj_bc

  + Christiaan Welvaart <spturtle@mandriva.org>
    - do not try to build the spu cross compiler on ppc
    - do not build soft-float libraries for ppc

  + Per Øyvind Karlsen <peroyvind@mandriva.org>
    - actually disable libffi when defining so (fixes #26518)
    - add autogen to buildrequires for %%check (fixes #17409)
    - add niagara support (P1000 & P1001, fixes #28503)
    - Fix %%g7 usage in TLS, add patch sparc-g7.dpatch, fixes glibc-2.4 build failure
      on sparc (Fabio M. Di Nitto) (P1000)

